const libs = `${process.cwd()}/libs`;
const log = require(`${libs}/log`)(module);
const execQuery = require(`${libs}/db/query_exec`);

 // Middleware that executes a query defined by a squel object in req.sql
function query(req, res, next) {
    let sql = req.sql.toParam();
    log.info(`Executando query ${req.sql.toString()}`);
    execute(sql.text, sql.values, (err, result) => {
        if(err) {
            log.error(err.stack);
            next(new Error('Request could not be satisfied due to a database error.'));
        } else {
            req.result = result;
            next();
        }
    });
}

function execute(text, values, cb) {
    execQuery(text, values).then((result) => {
        cb(null, result);
    }, (error) => {
        cb(error);
    });
}

module.exports = {query, execute};
